function traceObj(o) {
	var s = "";
	for (var i in o) { 
		try {
			//print out in form "propertyname:::value"
			s += i + ":::" + o[i] + "\n";
		} catch (ex) {
			//just ignore error and continue with next iteration(=property)
			continue;
		}
	}
	return s;
}

function peerConnectError(err) {
	trace("Erreur pendant procedure webRtc: " + err);
}
function peerConnectSuccess() {}

function updateVisitorCounter(i) {
	document.getElementById('visitorsCounter').innerHTML = "Speakers number: "+i;
}

//var serversForWebRTC = {};

var serversForWebRTC = {
	'iceServers': 	[	{'url': 'stun:stun.l.google.com:19302'},
						{'url':'stun:stun01.sipphone.com'},
						{'url':'stun:stun.ekiga.net'},
						{'url':'stun:stun.fwdnet.net'},
						{'url':'stun:stun.ideasip.com'},
						{'url':'stun:stun.iptel.org'},
						{'url':'stun:stun.rixtelecom.se'},
						{'url':'stun:stun.schlund.de'},
						{'url':'stun:stun1.l.google.com:19302'},
						{'url':'stun:stun2.l.google.com:19302'},
						{'url':'stun:stun3.l.google.com:19302'},
						{'url':'stun:stun4.l.google.com:19302'},
						{'url':'stun:stunserver.org'},
						{'url':'stun:stun.softjoys.com'},
						{'url':'stun:stun.voiparound.com'},
						{'url':'stun:stun.voipbuster.com'},
						{'url':'stun:stun.voipstunt.com'},
						{'url':'stun:stun.voxgratia.org'},
						{'url':'stun:stun.xten.com'},
						{
							'url': 'turn:numb.viagenie.ca',
							'credential': 'muazkh',
							'username': 'webrtc@live.com'
						},
						{
							'url': 'turn:192.158.29.39:3478?transport=udp',
							'credential': 'JZEOEt2V3Qb0y27GRntt2u2PAYA=',
							'username': '28224511:1379330808'
						},
						{
							'url': 'turn:192.158.29.39:3478?transport=tcp',
							'credential': 'JZEOEt2V3Qb0y27GRntt2u2PAYA=',
							'username': '28224511:1379330808'
						}
					]
	};

var peer = {};
var sigSocket = io.connect(window.location.protocol + '//' + window.location.host, {
	transports: ['websocket']
}); 

sigSocket.on('connect', function() {
	var helloMsg = {
		"isListenner": isListenner
	};
	sigSocket.emit('helloMessage', helloMsg);
	trace('sigsocket connecté, helloMsg envoyé');
});
sigSocket.on('reconnect', function() {
	var helloMsg = {
		"isListenner": isListenner
	};
	sigSocket.emit('helloMessage', helloMsg);
	trace('sigsocket reconnecté, helloMsg envoyé');
});

sigSocket.on('listennerOff', function() {
	if (isListenner) {
		trace('Erreur protocole: listennerOff reçu par listenner');
	} else if (listenner.ready) {
		closeConnectionWithPeer(false);
		listenner = {};
	} else {
		trace('Erreur protocole: listennerOff reçu mais pas de listenner connu');
	}
});

sigSocket.on('helloMessage', function(helloMsg) {
	if (isListenner && !helloMsg.isListenner) {
		trace("Nouveau speaker, on (listener) lui renvoie un hello msg");
		var helloMsg = {
			"isListenner": true
		};
		sigSocket.emit('helloMessage', helloMsg);
	} else if (!isListenner && helloMsg.isListenner) {
		trace("Le listenner est pret");
		indicateListennerReady();
	} else {
		trace('Erreur protocole: helloMsg missmatch, local isListenner: ' + isListenner + ' Remote isListenner: ' + helloMsg.isListenner);
	}
});

sigSocket.on('speakersNumbUpdate', function(numVisitors) {
	updateVisitorCounter(numVisitors);
});

function createPeerConnectionIfNeeded(peerId) {
	if (!peer.hasOwnProperty("pc")) {
		createPeerConnection(false);
		trace('peer Connection created (callee)');
	}
}

sigSocket.on('rtcSignal', function(signal) {
	try { // important car bug dans socket.io v1.0: les exceptions javascript user sont reportees comme des parser error
		switch (signal.type) {
			case "closePeerConnection":
				trace("On ferme la connection avec peer");
				closeConnectionWithPeer(false);
				break;
			case "iceCandidate":
				createPeerConnectionIfNeeded();
				if (signal.data.candidate) {
					peer.pc.addIceCandidate(new RTCIceCandidate(signal.data), peerConnectSuccess, peerConnectError);
					trace('ice candidate rxed et ajouté');
				} else {
					trace('erreur protocole, rtcSignal iceCandidate reçu mais pas de candidats');
				}
				break;
			case "sdp":
				createPeerConnectionIfNeeded();
				peer.pc.setRemoteDescription(new RTCSessionDescription(signal.data), peerConnectSuccess, peerConnectError);
				if (peer.pc.callRole == "callee") {
					peer.pc.createAnswer(gotSessionDescription, peerConnectError);
					trace('Callee: sdp rxed, set as remote description (CreateAnswer appellé)');
				} else {
					trace('Caller: sdp rxed, set as remote description');
				}
				break;
			default:
				trace('erreur protocole, rtcSignal inconnu reçu, signal:\n' + traceObj(signal));
				break;
		}
	} catch(e){
		trace(e);
	}
});

function rtcSig(sigType, data) {
	var sig = {};
	sig.type = sigType;
	if (typeof data == 'undefined') sig.data = null; else sig.data = data;
	return sig;
}

function createPeerConnection(isCaller, stream) {
	peer.pc = new RTCPeerConnection(serversForWebRTC);
	trace('Created local peer connection object');
	peer.pc.callRole = isCaller?"caller":"callee";	
	peer.pc.onicecandidate = gotIceCandidate;
	peer.pc.onaddstream = gotRemoteStream;
	peer.pc.onremovestream = remoteStreamRemoved;
	if (isCaller) {
		peer.pc.addStream(stream);
		trace('Caller: creating offer');
		peer.pc.createOffer(gotSessionDescription, peerConnectError);
	}	
}
function closeConnectionWithPeer(locallyOriginated) {
	if ( peer.hasOwnProperty("pc") ) {
		peer.pc.close();
		peer = {};
		if (locallyOriginated) {
			sigSocket.emit('rtcSignal', new rtcSig("closePeerConnection"));
		} else {
			cleanUpAfterConnectionClosedByPeer();
		}
		trace('Closed connection with peer' + (locallyOriginated?' onLocalReq':' onNetworkReq'));
	} else {
		trace('close peer connection déclenché, mais pas de connection trouvée');
	}
}

function gotSessionDescription(desc) {
	if (peer.hasOwnProperty("pc")) {
		peer.pc.setLocalDescription(desc);
		trace('Session description obtenue');
		sigSocket.emit('rtcSignal', new rtcSig("sdp", desc));
		trace('sdp txed au Peer');
	} else {
		trace('Session description obtenue mais peer connection pas retrouvée');
	}
}

function gotIceCandidate(event) {
	if (event.candidate) {
		sigSocket.emit('rtcSignal', new rtcSig("iceCandidate", event.candidate));
		trace('local ice callback: ICE candidate transmis au peer' + '\n' + event.candidate.candidate);
	} else {
		trace('local ice callback, pas (ou plus) de candidat');
	}
}

function gotRemoteStream(event) {
	try {
		manageGotRemoteStream(event.stream);
		trace('Got remote audio stream. Passé au manager audio');
	} catch (e) {
		trace(e);
	}
}
function remoteStreamRemoved(peerUuid, event) {
	trace('Bizarre: remote stream removed reçu (normalement pas utilisé car pas supporté sur Firefox)');
}

window.onunload = closeConnectionWithPeer(true);     
window.onbeforeunload = closeConnectionWithPeer(true);
